Program csoport;
{Ertekel a CSOPORT feladathoz}
Uses TestLib;
{Importlt elemek:
TCase:Integer;           a tesztesetek szma
Function DoTest:Boolean; a teszteset rtkelhet, van output fjl
Procedure Done;          az rtkels vgnek jelzse
Procedure Grade(rf, v:Integer); az rf rszfeladat rtklse, v=0/1
                                ha nem hvjuk, 0 rtket kap a teszeset
Procedure WriteMSG(rf:Integer; M:String); az rf rszfeladat rtkelsnekmagyarzata
            ha nem hvjuk, resen marad
TInF:Text;  teszt input, megnyitva
ToutF:Text; teszt output, megnyitva
CoutF:Text; a versenyz output llomnya, megnyitva
}
Const
  N1 = 1               ;(* az univerzum tipusa = N1..N2 *)
  N2 = 10000             ;(* N1 >= 0 !                    *)
Type
  Index  = N1..N2;
  NevTip=Index;
  Tartip = Array[Index] Of
                 Record
                   van:Boolean;
                   apa,csat:Integer
                 End;
   UnioHol = Record
              fa : Tartip;
              Rszamos,Szamos : Integer
          End;

{ az UnioHolvan adattipus muveleteinek megvalositasa }

Procedure Letesit(Var Sr : UnioHol);
  Var 
    j:Integer;
  Begin
    Sr.Rszamos := 0; Sr.Szamos:=0;
    For j:=N1 To N2 Do Begin
      Sr.fa[j].apa:=N2 +1;
      Sr.fa[j].van:=False;
    End;
  End;

procedure Holvan(Var Sr : UnioHol;
                     X : Index;
                 Var N : Nevtip);
  Var 
    j,k:Integer;
  Begin
    j:=X; N:=j;
    If Sr.fa[j].apa > N2 Then
      Begin
        Sr.Rszamos := Sr.Rszamos+1; Sr.Szamos:=Sr.Szamos+1;
        Sr.fa[j].apa:=-1; Sr.fa[j].csat:= j;
      End
    Else
      Begin
        While Sr.fa[N].apa > 0 Do
          N:=Sr.fa[N].apa;
        While j <> N Do                    (* utrovidites *)
          Begin
            k:=Sr.fa[j].apa;
            Sr.fa[j].apa:=N; j:=k
          End;
      End
  End (* Holvan *);

Procedure Unio(Var Sr : UnioHol;
                   N,M : Nevtip);
  Var   k:Nevtip;
  Begin
    If (N <> M) And (Sr.fa[N].apa < 0) And (Sr.fa[M].apa < 0) Then
      Begin
        Sr.Rszamos := Sr.Rszamos-1;
        If Sr.fa[N].apa > Sr.fa[M].apa Then
          Begin                            (* egyesites a nagyobbikhoz *)
            k:=N; N:=M; M:=k
          End;
        Sr.fa[N].apa:=Sr.fa[N].apa + Sr.fa[M].apa;
        Sr.fa[M].apa:=N;
        k:=Sr.fa[N].csat;
        Sr.fa[N].csat:= Sr.fa[M].csat;
        Sr.fa[M].csat:= k;
      End
  End (* Unio *);


Var
  t:Integer;

Procedure Eval;
Const
  MaxN=10000;
Var
  N,K,M,VM: Longint;
  S:UnioHol;
  i,j,x,Nx,Nxx:Integer;
Begin
  Letesit(S);
  ReadLn(ToutF,M);
  {$I-}
    ReadLn(CoutF, VM);
  {$I+}
    If IOResult<>0 Then Begin
      WriteMSG(1,'HIBA: Output formtum hiba');
      Exit;
    End;
    If M<>VM Then Begin
      WriteMSG(1,'HIBA: Az ekvivalens csoprotok szama hibs');
      Exit;
    End;

  Grade(1,1);
  WriteMSG(1,'HELYES');

  For i:=1 To M Do Begin
    Read(ToutF, x);
    Holvan(S, x, Nx);
    While Not SeekEoln(ToutF) Do Begin
      Read(ToutF,x);
      Holvan(S, x, Nxx); 
      Unio(S, Nx, Nxx)  
    End{while};
    ReadLn(ToutF);
  End{for M};

  For j:=1 To M Do Begin
    {$I-}
      Read(CoutF, x);
    {$I+}
      If IOResult<>0 Then Begin
        WriteMSG(2,'HIBA: Output formtum hiba');
        Exit;
      End;
      If (x<1)Or (x>MaxN) Then Begin
        WriteMSG(2,'HIBA: Hibs felhasznl');
        Exit;
      End;
    If S.Fa[x].apa>N2 Then Begin
      WriteMSG(2,'HIBA: Hibs felhasznl');
      Exit;
    End;
    S.Fa[x].van:=True;
    Holvan(S, x,Nx);

    While Not SeekEoln(CoutF) Do Begin
    {$I-}
      Read(CoutF, x);
    {$I+}
      If IOResult<>0 Then Begin
        WriteMSG(2,'HIBA: Output formtum hiba');
        Exit;
      End;

      If (x<1)Or (x>MaxN) Then Begin
        WriteMSG(2,'HIBA: Hibs felhasznl');
        Exit;
      End;
      If S.Fa[x].apa>N2 Then Begin
        WriteMSG(2,'HIBA: Hibs felhasznl');
        Exit;
      End;
      HolVan(S,x,Nxx);
      If Nx<>Nxx Then Begin
        WriteMSG(2,'HIBA: Hibs csoport');
        Exit;
      End;
      S.Fa[x].van:=True;
    End{while seekoln};
    ReadLn(CoutF);

    x:=Nx;
    Repeat
      If Not S.Fa[x].van Then Begin
        WriteMSG(2,'HIBA: Hibs csoport');
        Exit;
      End;
      x:=S.Fa[x].csat;
    Until x=Nx;

  End{for M}; 

  Grade(2,1);
  WriteMSG(2,'HELYES');
End{Eval};

Begin{Prog}
  For t:=1 To TCase Do Begin
    If DoTest Then
      Eval;
  End;
  Done;
End.
